applyToPlayers = (func) ->
	screen = SCREENMAN\GetTopScreen!

	-- gameplay
	for i=1, 2
		if field = screen\GetChild 'PlayerP'..i
			func field, i

	-- editor (god knows why the playfield isn't named)
	if children = screen\GetChild ''
		for child in *children
			if tostring(child)\find'Player'
				func child, 1

vibrate =
	update: (mod, pos) =>
		mag = mod.magnitude or 50
		applyToPlayers =>
			@vibrate!
			@effectmagnitude mag, mag, 0

	finish: =>
		applyToPlayers =>
			@stopeffect!

clock =
	update: (mod, pos) =>
		applyToPlayers (pnum) =>
			@rotationz math.min(pos * 1.33, 1) * 360 * (pnum == 1 and 1 or -1)

roll =
	update: (mod, pos) =>
		applyToPlayers =>
			@rotationx (pos ^ 0.5) * 360

twirl =
	update: (mod, pos) =>
		applyToPlayers =>
			@rotationy 180 + (pos ^ 0.5) * 180

mentalCollapse =
	start: =>
		@actorData = {}
		SCREENMAN\GetTopScreen!\RunCommandsOnChildren (child) -> with child
			if not tostring(child)\find'Player'
				@actorData[child] =
					x: \GetX!
					y: \GetY!
					rotation: \GetRotationZ!
					alpha: \GetDiffuseAlpha!

				\accelerate 19
				\diffusealpha 0
				\rotationz math.random -10, 10
				\addy math.random 20, 50

	finish: =>
		SCREENMAN\GetTopScreen!\RunCommandsOnChildren (child) -> with child
			-- restore old properties
			if data = @actorData[child]
				\stoptweening!
				\xy data.x, data.y
				\rotationz data.rotation

				\linear 1
				\diffusealpha data.alpha

chaos =
	update: (mod, pos) =>
		mag = (mod.magnitude or 10) * (1 - pos)
		with SCREENMAN\GetTopScreen!
			\vibrate!
			\effectmagnitude mag, mag, 0

	finish: =>
		with SCREENMAN\GetTopScreen!
			\stopeffect!

zoomoutin =
	update: (mod, pos) =>
		applyToPlayers =>
			@zoom pos^0.3

ModList = {
	-- mod definition:
	-- {
	-- 	start:        <time mod should begin (in beats)>
	-- 	after:        <mod begins x beats after the previous one>
	-- 	finish:       <time mod should finish (in beats)>
	-- 	len:          <how long the mod lasts (in beats) (can leave out 'finish' if provided)>
	-- 	delay:        <how much the mod should be delayed before actually starting
	-- 	               this is useful for doing effects during stops>
	-- 	mods:         <a string of .crs format mods>
	-- 	lua:          <a lua function. it's given two arguments:
	-- 	               the first is 'pos', which is the positition
	-- 	               in time in the current mod
	-- 	               as in, if the mod is half done, pos will be 0.5
	-- 	               the second argument is the mod table itself
	-- 	               the last is a boolean, whether it's the last time the function is being called, 'done'>
	-- 	player:       <player to give the mods to, either PLAYER_1 or PLAYER_2,
	-- 	               will be both if left out>
	-- 	once:         <if true, will only make the lua function be run once,
	-- 	               instead of for the duration of the mod
	-- 	repeatPeriod: <beats between each repetition of the line>
	-- 	repeatUntil:  <will repeat the specified line until the specified beat>
	-- 	repeatTimes:  <will repeat the line a specified number of times>
	-- }

	{ start: 0, len: math.huge, mods: '0.8x' }

	{ start: 111, len: 1, lua: vibrate }

}

return ModList
